  using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            {

                CategoryBuilder.Create("The Last of Us Part II", "Stranger Things mod - by reteretei", ModAPI.LoadSprite("ic/cat_icon.png"));

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Ellie  -TLoUII",
                        DescriptionOverride = "A brave, 14-year-old girl, Ellie has grown up in this harsh world and it is all she has ever known. She’s an orphan who was raised in a boarding school run by the military within the bounds of the quarantine zone. Naïve and curious about the outside world, she is wise beyond her years and highly capable of taking care of herself and those around her. Obsessed with comic books, CDs, and other pop culture, her knowledge base is filled by the remnants of a world that no longer exists.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/ellie.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/ellie.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/ellie_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/ellie_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/ellie_upperarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/ellie_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/ellie_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Joel Miller  -TLoUII",
                        DescriptionOverride = "A brave, 14-year-old girl, Ellie has grown up in this harsh world and it is all she has ever known. She’s an orphan who was raised in a boarding school run by the military within the bounds of the quarantine zone. Naïve and curious about the outside world, she is wise beyond her years and highly capable of taking care of herself and those around her. Obsessed with comic books, CDs, and other pop culture, her knowledge base is filled by the remnants of a world that no longer exists.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/joel.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/joel.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/joel_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/joel_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/joel_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/joel_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Dina -TLoUII",
                        DescriptionOverride = "We have a family. She doesn't get to be more important than that.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/dina.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/dina.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/dina_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/dina_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/dina_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/dina_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Abigail (Abby) Anderson -TLoUII",
                        DescriptionOverride = "Abby is the daughter of Jerry Anderson, the head surgeon who worked for the Fireflies and was killed by Joel Miller when rescuing Ellie. Her father raised her as a member of the Fireflies during the apocalypse and took her to live in Salt Lake City where he worked on making a vaccine for the Cordyceps brain infection.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/abby.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/abby.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/abby_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/abby_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/abby_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/abby_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Tommy Miller -TLoUII",
                        DescriptionOverride = "Tommy was born after his older brother Joel and grew up in Texas alongside him. As a child, Tommy shared his brother's love of music and also developed an interest in college football. Later, Tommy became an uncle when Joel had a daughter named Sarah. As an adult, he lived in Travis County and worked in construction alongside Joel. He befriended a local farmer, Louis, and owned a pick-up truck.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/tommy.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/tommy.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/tommy_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/tommy_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/tommy_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/tommy_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Jesse -TLoUII",
                        DescriptionOverride = "My friend's problems are my problems",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/jesse.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/jesse.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/jesse_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/jesse_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/jesse_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/jesse_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Clicker -TLoUII",
                        DescriptionOverride = "Clickers appear less human than Runners and Stalkers, with faces that are completely skewed and scarred by fungus developed from their infected brains.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/clicker.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/clicker.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/clicker_head.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Ellie's Knife -TLoUII",
                        DescriptionOverride = "My friend's problems are my problems",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/el_knife.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/ellie_knife.png", 2.0f); 
                            Instance.FixColliders();
                            
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Nora Harris -TLoUII",
                        DescriptionOverride = "I'm not giving up my friend.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/nora.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/nora.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/nora_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontLeg").Find("UpperLegFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/nora_upperleg.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontLeg").Find("LowerLegFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/nora_lowerleg.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("BackLeg").Find("UpperLeg"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/nora_upperleg.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("BackLeg").Find("LowerLeg"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/nora_lowerleg.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Owen Moore -TLoUII",
                        DescriptionOverride = "We can choose to be happy.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/owen.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/owen.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/owen_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Manny Alvarez  -TLoUII",
                        DescriptionOverride = "A gentleman never tells.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/manny.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/manny.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/manny_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/manny_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/manny_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/manny_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontLeg").Find("UpperLegFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/manny_upperleg.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Runner (Female) -TLoUII",
                        DescriptionOverride = "They might still look like people, but that person is not in there anymore.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/runnerw.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/runner_w.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/runnerw_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/runnerw_upperbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/runnerw_middlebody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/runnerw_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Runner (Male) -TLoUII",
                        DescriptionOverride = "They might still look like people, but that person is not in there anymore.",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/runnerm.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/runner_m.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/runnerm_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Maria Miller -TLoUII",
                        DescriptionOverride = "It takes one. One fuck up. One fuck up and then I turn into one of those widows. Okay?",
                        CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/maria.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/maria.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/maria_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/maria_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Semi-Auto Pistol",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                    ThumbnailOverride = ModAPI.LoadSprite("ic/sap.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();

                        var MakarovSlide = Instance.transform.Find("Slide");
                        MakarovSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/sapSlide.png");

                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/sap.png");

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.BulletsPerShot = 1;
                        firearm.barrelPosition = new Vector2(0.15f, 0.08f);
                        firearm.ShotSounds = new AudioClip[]
                        {
                              ModAPI.LoadSound("we/sap.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "sap";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil = 0.1f;
                        customCartridge.ImpactForce = 0.1f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Semi-Auto Pistol (Upgraded)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                    ThumbnailOverride = ModAPI.LoadSprite("ic/sapu.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();

                        var MakarovSlide = Instance.transform.Find("Slide");
                        MakarovSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/sapuSlide.png");

                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/sapu.png");

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.BulletsPerShot = 1;
                        firearm.barrelPosition = new Vector2(0.15f, 0.08f);
                        firearm.ShotSounds = new AudioClip[]
                        {
                              ModAPI.LoadSound("we/sap.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "sap";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil = 0.1f;
                        customCartridge.ImpactForce = 0.1f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Military Pistol",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("The Last of Us Part II"),
                    ThumbnailOverride = ModAPI.LoadSprite("ic/mp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();

                        var MakarovSlide = Instance.transform.Find("Slide");
                        MakarovSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/mpSlide.png");

                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/mp.png");

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.BulletsPerShot = 1;
                        firearm.barrelPosition = new Vector2(0.15f, 0.08f);
                        firearm.ShotSounds = new AudioClip[]
                        {
                              ModAPI.LoadSound("we/mp.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "mp";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil = 0.1f;
                        customCartridge.ImpactForce = 0.1f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );
            }
        }
    }
}